Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -6181,638 +4853,309 @@
  ************************************************************************/
 #define SET_SXP_BANK            0x0100
 #define SCSI_PHASE_INVALID      0x87FF
-int  qla1280_check_for_dead_scsi_bus(scsi_qla_host_t *ha, srb_t *sp)
-{
-    uint16_t  config_reg, scsi_control;
-    device_reg_t    *reg = ha->iobase;
-    uint32_t  b;
-    Scsi_Cmnd       *cp;
-
-    /*
-     * If SCSI Bus is Dead because of bad termination,
-     * we will return a status of Selection timeout.
-     */
- 
-     cp = sp->cmd;
-     b = SCSI_BUS_32(cp);
-    if (ha->bus_settings[b].scsi_bus_dead)
-    {
-        WRT_REG_WORD(&reg->host_cmd, HC_PAUSE_RISC);
-        config_reg = RD_REG_WORD(&reg->cfg_1);
-        WRT_REG_WORD(&reg->cfg_1,SET_SXP_BANK);
-        scsi_control = RD_REG_WORD(&reg->scsiControlPins);
-        WRT_REG_WORD(&reg->cfg_1,config_reg);
-        WRT_REG_WORD(&reg->host_cmd, HC_RELEASE_RISC);
-
-        if (scsi_control == SCSI_PHASE_INVALID)
-        {
-            CMD_RESULT(cp) = DID_NO_CONNECT << 16;
-            CMD_HANDLE(cp) = (unsigned char *) 0;
-            /* ha->actthreads--; */
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-            sti(); 
-            (*(cp)->scsi_done)(cp);
-            cli(); 
-#else
-            (*(cp)->scsi_done)(cp);
-#endif
-            return(TRUE);   /* bus is dead */
-        }
-        else
-        {
-            ha->bus_settings[b].scsi_bus_dead = FALSE;
-            ha->bus_settings[b].failed_reset_count= 0; 
-        }
-    }
-    return(FALSE);   /* bus is not dead */
-}
-
-STATIC uint8_t
-qla12160_set_target_parameters(scsi_qla_host_t *ha, uint32_t b, uint32_t t, uint32_t l, nvram160_t *nv)
+static int
+qla1280_check_for_dead_scsi_bus(struct scsi_qla_host *ha, unsigned int bus)
 {
-    uint16_t        mb[MAILBOX_REGISTER_COUNT];
+	uint16_t config_reg, scsi_control;
+	struct device_reg *reg = ha->iobase;
 
-    /* Set Target Parameters. */
-    mb[0] = MBC_SET_TARGET_PARAMETERS;
-    mb[1] = (uint16_t)(b ? t | BIT_7 :t);
-    mb[1] <<= 8;
-    mb[2] = nv->bus[b].target[t].parameter.c << 8;
-    mb[2] |= TP_AUTO_REQUEST_SENSE;
-    mb[2] &= ~TP_STOP_QUEUE;
-    mb[2] |=  (nv->bus[b].target[t].flags.enable_ppr << 5);
-    mb[3] = nv->bus[b].target[t].flags.sync_offset << 8;
-    mb[3] |= nv->bus[b].target[t].sync_period;
+	if (ha->bus_settings[bus].scsi_bus_dead) {
+		WRT_REG_WORD(&reg->host_cmd, HC_PAUSE_RISC);
+		config_reg = RD_REG_WORD(&reg->cfg_1);
+		WRT_REG_WORD(&reg->cfg_1, SET_SXP_BANK);
+		scsi_control = RD_REG_WORD(&reg->scsiControlPins);
+		WRT_REG_WORD(&reg->cfg_1, config_reg);
+		WRT_REG_WORD(&reg->host_cmd, HC_RELEASE_RISC);
 
-    mb[6] = nv->bus[b].target[t].flags.ppr_options << 8;
-    mb[6] |= nv->bus[b].target[t].flags.ppr_bus_width;
-    return( qla1280_mailbox_command(ha, BIT_6|BIT_3|BIT_2|BIT_1|BIT_0, &mb[0]) ) ;
+		if (scsi_control == SCSI_PHASE_INVALID) {
+			ha->bus_settings[bus].scsi_bus_dead = 1;
+#if 0
+			CMD_RESULT(cp) = DID_NO_CONNECT << 16;
+			CMD_HANDLE(cp) = INVALID_HANDLE;
+			/* ha->actthreads--; */
+
+			(*(cp)->scsi_done)(cp);
+#endif
+			return 1;	/* bus is dead */
+		} else {
+			ha->bus_settings[bus].scsi_bus_dead = 0;
+			ha->bus_settings[bus].failed_reset_count = 0;
+		}
+	}
+	return 0;		/* bus is not dead */
 }
 
-STATIC void
-qla12160_get_target_parameters(scsi_qla_host_t *ha, uint32_t b, uint32_t t, uint32_t l)
+static void
+qla12160_get_target_parameters(struct scsi_qla_host *ha, Scsi_Device *device)
 {
-    uint16_t        mb[MAILBOX_REGISTER_COUNT];
+	uint16_t mb[MAILBOX_REGISTER_COUNT];
+	int bus, target, lun;
 
-    mb[0] = MBC_GET_TARGET_PARAMETERS;
-    mb[1] = (uint16_t)(b ? t | BIT_7 :t);
-    mb[1] <<= 8;
-    qla1280_mailbox_command(ha, BIT_6|BIT_3|BIT_2|BIT_1|BIT_0, &mb[0]);
-    if( mb[3] != 0 )
-    printk(KERN_INFO "scsi(%d:%d:%d:%d): Synchronous tranfer at period %d, offset %d. \n",
-        (int)ha->host_no, b, t, l, (mb[3] &0xff), (mb[3] >> 8));
+	bus = device->channel;
+	target = device->id;
+	lun = device->lun;
 
-    if ( (mb[2] & BIT_5) &&  ((mb[6] >> 8) & 0xff) >= 2 )
-            printk(KERN_INFO "scsi(%d:%d:%d:%d): Dual Transition enabled.\n",
-                          (int)ha->host_no, b, t, l);
-}
 
+	mb[0] = MBC_GET_TARGET_PARAMETERS;
+	mb[1] = (uint16_t) (bus ? target | BIT_7 : target);
+	mb[1] <<= 8;
+	qla1280_mailbox_command(ha, BIT_6 | BIT_3 | BIT_2 | BIT_1 | BIT_0,
+				&mb[0]);
 
-#ifdef QL_DEBUG_ROUTINES
-/****************************************************************************/
-/*                         Driver Debug Functions.                          */
-/****************************************************************************/
+	printk(KERN_INFO "scsi(%li:%d:%d:%d):", ha->host_no, bus, target, lun);
 
-/*
- *  Get byte from I/O port
- */
-STATIC uint8_t
-qla1280_getbyte(uint8_t *port)
-{
-    uint8_t ret;
+	if (mb[3] != 0) {
+		printk(" Sync: period %d, offset %d",
+		       (mb[3] & 0xff), (mb[3] >> 8));
+		if (mb[2] & BIT_13)
+			printk(", Wide");
+		if ((mb[2] & BIT_5) && ((mb[6] >> 8) & 0xff) >= 2)
+			printk(", DT");
+	} else
+		printk(" Async");
 
-#if MEMORY_MAPPED_IO
-    ret = *port;
-#else
-    ret = inb((int)port);
-#endif
-
-    if (ql_debug_print)
-    {
-        qla1280_print("qla1280_getbyte: address = ");
-        qla1280_output_number((uint32_t)port, 16);
-        qla1280_print(" data = 0x");
-        qla1280_output_number((uint32_t)ret, 16);
-        qla1280_print("\n\r");
-    }
-
-    return(ret);
+	if (DEV_SIMPLE_TAGS(device))
+		printk(", Tagged queuing: depth %d", device->queue_depth);
+	printk("\n");
 }
 
-/*
- *  Get word from I/O port
- */
-STATIC uint16_t
-qla1280_getword(uint16_t *port)
-{
-    uint16_t ret;
 
-#if MEMORY_MAPPED_IO
-    ret = *port;
-#else
-    ret = inw((int)port);
-#endif
-
-    if (ql_debug_print)
-    {
-        qla1280_print("qla1280_getword: address = ");
-        qla1280_output_number((uint32_t)port, 16);
-        qla1280_print(" data = 0x");
-        qla1280_output_number((uint32_t)ret, 16);
-        qla1280_print("\n\r");
-    }
-
-    return(ret);
-}
-
-/*
- *  Get double word from I/O port
- */
-STATIC uint32_t
-qla1280_getdword(uint32_t *port)
+#if DEBUG_QLA1280
+static void
+__qla1280_dump_buffer(char *b, int size)
 {
-    uint32_t ret;
+	int cnt;
+	u8 c;
 
-#if MEMORY_MAPPED_IO
-    ret = *port;
-#else
-    ret = inl((int)port);
-#endif
+	printk(KERN_DEBUG " 0   1   2   3   4   5   6   7   8   9   Ah  "
+	       "Bh  Ch  Dh  Eh  Fh\n");
+	printk(KERN_DEBUG "---------------------------------------------"
+	       "------------------\n");
 
-    if (ql_debug_print)
-    {
-        qla1280_print("qla1280_getdword: address = ");
-        qla1280_output_number((uint32_t)port, 16);
-        qla1280_print(" data = 0x");
-        qla1280_output_number((uint32_t)ret, 16);
-        qla1280_print("\n\r");
-    }
+	for (cnt = 0; cnt < size;) {
+		c = *b++;
 
-    return(ret);
-}
-
-/*
- *  Send byte to I/O port
- */
-STATIC void
-qla1280_putbyte(uint8_t *port, uint8_t data)
-{
-#if MEMORY_MAPPED_IO
-    *port = data;
-#else
-    outb(data, (int)port);
-#endif
-
-    if (ql_debug_print)
-    {
-        qla1280_print("qla1280_putbyte: address = ");
-        qla1280_output_number((uint32_t)port, 16);
-        qla1280_print(" data = 0x");
-        qla1280_output_number((uint32_t)data, 16);
-        qla1280_print("\n\r");
-    }
-}
-
-/*
- *  Send word to I/O port
- */
-STATIC void
-qla1280_putword(uint16_t *port, uint16_t data)
-{
-#if MEMORY_MAPPED_IO
-    *port = data;
-#else
-#ifdef _LINUX_IOPORTS
-    outw(data, (int)port);
-#else
-    outw((int)port, data);
-#endif
-#endif
-
-    if (ql_debug_print)
-    {
-        qla1280_print("qla1280_putword: address = ");
-        qla1280_output_number((uint32_t)port, 16);
-        qla1280_print(" data = 0x");
-        qla1280_output_number((uint32_t)data, 16);
-        qla1280_print("\n\r");
-    }
-}
-
-/*
- *  Send double word to I/O port
- */
-STATIC void
-qla1280_putdword(uint32_t *port, uint32_t data)
-{
-#if MEMORY_MAPPED_IO
-    *port = data;
-#else
-#ifdef _LINUX_IOPORTS
-    outl(data,(int)port);
-#else
-    outl((int)port, data);
-#endif
-#endif
-
-    if (ql_debug_print)
-    {
-        qla1280_print("qla1280_putdword: address = ");
-        qla1280_output_number((uint32_t)port, 16);
-        qla1280_print(" data = 0x");
-        qla1280_output_number((uint32_t)data, 16);
-        qla1280_print("\n\r");
-    }
-}
-
-/*
- * Dummy function to prevent warnings for
- * declared and unused debug functions
- */
-void
-qla1280_debug(void)
-{
-    qla1280_getbyte(0);
-    qla1280_getword(0);
-    qla1280_getdword(0);
-    qla1280_putbyte(0, 0);
-    qla1280_putword(0, 0);
-    qla1280_putdword(0, 0);
+		printk("0x%02x", c);
+		cnt++;
+		if (!(cnt % 16))
+			printk("\n");
+		else
+			printk(" ");
+	}
+	if (cnt % 16)
+		printk("\n");
 }
 
-/*
- *  Out character to COM2 port.
- *      PORT must be at standard address for COM2 = 0x2F8,
- *      or COM1 = 0x3F8
- */
-#define OUTB(addr,data)   outb((data),(addr))
-
-STATIC void
-qla1280_putc(uint8_t c)
-{
-#ifdef QL_DEBUG_CONSOLE
-    printk("%c", c);
-#else
-    int     com_addr              = 0x2f8;
-    int     hardware_flow_control = 1;
-    int     software_flow_control = 0;
-    uint8_t data;
-
-    /* Wait for transmitter holding and shift registers for empty. */
-    do
-    {
-        data = inb(com_addr+5);
-    }while (!(data & BIT_6));
-
-    /*
-    * Set BAUD rate for COM2 to 19200 (0x6)
-    */
-
-    /* Select rate divisor. */
-    OUTB(com_addr+3, 0x83); 
-
-    /* BAUD rate divisor LSB. */
-    OUTB(com_addr, 0xc);                    /* 0xC = 9600 baud */
-
-    /* BAUD rate divisor MSB. */
-    OUTB(com_addr+1, 0);
-
-    /* Set No parity, 8 bits, 1 stop bit and
-    select interrupt enable register. */
-    OUTB(com_addr+3, 3);
-
-    /* Disable interrupts. */
-    OUTB(com_addr+1, 0);
-
-    /* Set data terminal ready and request to send */
-    OUTB(com_addr+4,3);
-
-    if (hardware_flow_control)
-    {
-        /* Wait for clear-to-send and data-set-ready */
-        do
-        {
-            data = inb(com_addr+6) & (BIT_5 + BIT_4);
-        }while (data != (BIT_5 + BIT_4));
-    }
-    else if (software_flow_control)
-    {
-        /* Test for data ready. */
-        data = inb(com_addr+5);
-        if (data & BIT_0)
-        {
-            /* If XOFF */
-            data = inb(com_addr);
-            if (data == '\023')
-            {
-                /* Wait for XON */
-                do
-                {
-                    /* Wait for char */
-                    do
-                    {
-                        data = inb(com_addr+5);
-                    }while (!(data & BIT_0));
-                    data = inb(com_addr);
-                }while (data != '\021');
-            }
-        }
-    }
-
-    /* Output character. */
-    OUTB(com_addr, c);
-#endif
-}
-
-/*
- *  Out NULL terminated string to COM port.
- */
-STATIC void
-qla1280_print(caddr_t s)
-{
-    if (ql_debug_print)
-    {
-#ifdef QL_DEBUG_CONSOLE
-        printk("%s",s);
-#else
-        /* Output string. */
-        while (*s)
-            qla1280_putc(*s++);
-#endif
-    }
-}
-
-/*
- *  Output long number to COM port.
- */
-STATIC void
-qla1280_output_number(uint32_t n, uint8_t base)
-{
-    int8_t str[12];
-    int8_t *s     = &str[11];
-    int8_t output = 0;
-    int8_t hex    = FALSE;
-
-    if (ql_debug_print)
-    {
-        if (base == 10 || base == 16)
-        {
-            if (base == 16 && n > 9)
-                hex = TRUE;
-
-            *s = 0;
-            do
-            {
-                s--;
-                *s = n % base;
-                if (*s > 9)
-                    *s += 55;
-                else
-                    *s += '0';
-                n /= base;
-            }while (n);
-
-            for (; *s; s++)
-            {
-                if (*s != '0')
-                    output = 1;
-                if (output)
-                    qla1280_putc(*s);
-            }
-            if (!output)
-                qla1280_putc(*--s);
-
-            if (hex)
-                qla1280_putc('h');
-        }
-    }
-}
-
-STATIC void
-qla1280_dump_buffer(caddr_t b, uint32_t size)
-{
-    uint32_t cnt;
-    uint8_t c;
-
-    if (ql_debug_print)
-    {
-        qla1280_print(
-                " 0   1   2   3   4   5   6   7   8   9   Ah  Bh  Ch  Dh  Eh  Fh\n\r");
-        qla1280_print(
-                "---------------------------------------------------------------\n\r");
-
-        for (cnt = 0; cnt < size; )
-        {
-            c = *b++;
-            if (c < 16)
-                qla1280_putc(' ');
-            qla1280_output_number((uint32_t)c, 16);
-            cnt++;
-            if (!(cnt % 16))
-                qla1280_print("\n\r");
-            else if (c < 10)
-                qla1280_print("  ");
-            else
-                qla1280_putc(' ');
-        }
-        if (cnt % 16)
-            qla1280_print("\n\r");
-    }
-}
 /**************************************************************************
  *   ql1280_print_scsi_cmd
  *
  **************************************************************************/
-void qla1280_print_scsi_cmd(Scsi_Cmnd *cmd)
+static void
+__qla1280_print_scsi_cmd(Scsi_Cmnd * cmd)
 {
-    scsi_qla_host_t *ha;
-    struct Scsi_Host  *host = cmd->host;
-    srb_t           *sp;
-   /* struct scatterlist *sg; */
-
-    int i;
-    ha = (scsi_qla_host_t *) host->hostdata;
-
-    ql_debug_print = 1;
-    sp = (srb_t *) CMD_SP(cmd);
-    sprintf(debug_buff,"SCSI Command @= 0x%p, Handle=0x%p\n\r", cmd, CMD_HANDLE(cmd));
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"  chan=%d, target = 0x%02x, lun = 0x%02x, cmd_len = 0x%02x\n\r",
-            cmd->channel, cmd->target, cmd->lun, cmd->cmd_len);
-    qla1280_print(debug_buff);
-    qla1280_print(" CDB = ");
-    for (i = 0; i < cmd->cmd_len; i++)
-    {
-        sprintf(debug_buff,"0x%02x ", cmd->cmnd[i]);
-        qla1280_print(debug_buff);
-    }
-    sprintf(debug_buff,"  seg_cnt =%d\n\r",cmd->use_sg);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"  request buffer=0x%p, request buffer len=0x%x\n\r",cmd->request_buffer,cmd->request_bufflen);
-    qla1280_print(debug_buff);
-    /* if( cmd->use_sg )
-    {
-       sg = (struct scatterlist *) cmd->request_buffer;
-       qla1280_print("  SG buffer: \n\r");
-       qla1280_dump_buffer((caddr_t)sg, (cmd->use_sg*sizeof(struct scatterlist)) );
-    } */
-    sprintf(debug_buff,"  tag=%d, flags=0x%x, transfersize=0x%x \n\r", 
-            cmd->tag, cmd->flags,cmd->transfersize );
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"  Pid=%d, SP=0x%p\n\r", (int)cmd->pid, CMD_SP(cmd));
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"  r_start=0x%lx, u_start=0x%lx\n\r",sp->r_start,sp->u_start);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff," underflow size = 0x%x, direction=0x%x, req.cmd=0x%x \n\r", cmd->underflow, sp->dir,cmd->request.cmd);    
-    qla1280_print(debug_buff);
+	struct scsi_qla_host *ha;
+	struct Scsi_Host *host = CMD_HOST(cmd);
+	struct srb *sp;
+	/* struct scatterlist *sg; */
+
+	int i;
+	ha = (struct scsi_qla_host *)host->hostdata;
+
+	sp = (struct srb *)CMD_SP(cmd);
+	printk("SCSI Command @= 0x%p, Handle=0x%p\n", cmd, CMD_HANDLE(cmd));
+	printk("  chan=%d, target = 0x%02x, lun = 0x%02x, cmd_len = 0x%02x\n",
+	       SCSI_BUS_32(cmd), SCSI_TCN_32(cmd), SCSI_LUN_32(cmd),
+	       CMD_CDBLEN(cmd));
+	printk(" CDB = ");
+	for (i = 0; i < cmd->cmd_len; i++) {
+		printk("0x%02x ", cmd->cmnd[i]);
+	}
+	printk("  seg_cnt =%d\n", cmd->use_sg);
+	printk("  request buffer=0x%p, request buffer len=0x%x\n",
+	       cmd->request_buffer, cmd->request_bufflen);
+	/* if (cmd->use_sg)
+	   {
+	   sg = (struct scatterlist *) cmd->request_buffer;
+	   printk("  SG buffer: \n");
+	   qla1280_dump_buffer(1, (char *)sg, (cmd->use_sg*sizeof(struct scatterlist)));
+	   } */
+	printk("  tag=%d, flags=0x%x, transfersize=0x%x \n",
+	       cmd->tag, cmd->flags, cmd->transfersize);
+	printk("  Pid=%li, SP=0x%p\n", cmd->pid, CMD_SP(cmd));
+	printk(" underflow size = 0x%x, direction=0x%x\n",
+	       cmd->underflow, sp->dir);
 }
+
 /**************************************************************************
  *   ql1280_dump_device
  *
  **************************************************************************/
-void
-ql1280_dump_device(scsi_qla_host_t *ha)
+static void
+ql1280_dump_device(struct scsi_qla_host *ha)
 {
 
-    Scsi_Cmnd       *cp;
-    srb_t           *sp;
-    int i;
-    qla1280_print("Outstanding Commands on controller:\n\r");   
-    for ( i=0; i < MAX_OUTSTANDING_COMMANDS; i++ )
-    {
-        if( (sp = ha->outstanding_cmds[i]) == NULL )
-            continue;
-        if( (cp = sp->cmd) == NULL )
-            continue;
-        qla1280_print_scsi_cmd(cp);
-    }
+	Scsi_Cmnd *cp;
+	struct srb *sp;
+	int i;
 
-}
-#endif
+	printk(KERN_DEBUG "Outstanding Commands on controller:\n");
 
-#ifdef  QLA1280_UNUSED 
-/**************************************************************************
- *   ql1280_dump_regs
- *
- **************************************************************************/
-static void qla1280_dump_regs(struct Scsi_Host *host)
-{
-    printk("Mailbox registers:\n");
-    printk("qla1280 : mbox 0 0x%04x \n", inw(host->io_port + 0x70));
-    printk("qla1280 : mbox 1 0x%04x \n", inw(host->io_port + 0x72));
-    printk("qla1280 : mbox 2 0x%04x \n", inw(host->io_port + 0x74));
-    printk("qla1280 : mbox 3 0x%04x \n", inw(host->io_port + 0x76));
-    printk("qla1280 : mbox 4 0x%04x \n", inw(host->io_port + 0x78));
-    printk("qla1280 : mbox 5 0x%04x \n", inw(host->io_port + 0x7a));
+	for (i = 0; i < MAX_OUTSTANDING_COMMANDS; i++) {
+		if ((sp = ha->outstanding_cmds[i]) == NULL)
+			continue;
+		if ((cp = sp->cmd) == NULL)
+			continue;
+		qla1280_print_scsi_cmd(1, cp);
+	}
 }
 #endif
 
 
+enum tokens {
+	TOKEN_NVRAM,
+	TOKEN_SYNC,
+	TOKEN_WIDE,
+	TOKEN_PPR,
+	TOKEN_VERBOSE,
+	TOKEN_DEBUG,
+};
+
+struct setup_tokens {
+	char *token;
+	int val;
+};
+
+static struct setup_tokens setup_token[] __initdata = 
+{
+	{ "nvram", TOKEN_NVRAM },
+	{ "sync", TOKEN_SYNC },
+	{ "wide", TOKEN_WIDE },
+	{ "ppr", TOKEN_PPR },
+	{ "verbose", TOKEN_VERBOSE },
+	{ "debug", TOKEN_DEBUG },
+};
+
 
-#if  STOP_ON_ERROR 
 /**************************************************************************
- *   ql1280_panic
+ *   qla1280_setup
  *
+ *   Handle boot parameters. This really needs to be changed so one
+ *   can specify per adapter parameters.
  **************************************************************************/
-static void qla1280_panic(char *cp, struct Scsi_Host *host)
+static int __init
+qla1280_setup(char *s)
 {
-    scsi_qla_host_t *ha;
-    long  *fp;
+	char *cp, *ptr;
+	unsigned long val;
+	int toke;
+
+	cp = s;
+
+	while (cp && (ptr = strchr(cp, ':'))) {
+		ptr++;
+		if (!strcmp(ptr, "yes")) {
+			val = 0x10000;
+			ptr += 3;
+		} else if (!strcmp(ptr, "no")) {
+ 			val = 0;
+			ptr += 2;
+		} else
+			val = simple_strtoul(ptr, &ptr, 0);
+
+		switch ((toke = qla1280_get_token(cp))) {
+		case TOKEN_NVRAM:
+			if (!val)
+				driver_setup.no_nvram = 1;
+			break;
+		case TOKEN_SYNC:
+			if (!val)
+				driver_setup.no_sync = 1;
+			else if (val != 0x10000)
+				driver_setup.sync_mask = val;
+			break;
+		case TOKEN_WIDE:
+			if (!val)
+				driver_setup.no_wide = 1;
+			else if (val != 0x10000)
+				driver_setup.wide_mask = val;
+			break;
+		case TOKEN_PPR:
+			if (!val)
+				driver_setup.no_ppr = 1;
+			else if (val != 0x10000)
+				driver_setup.ppr_mask = val;
+			break;
+		case TOKEN_VERBOSE:
+			qla1280_verbose = val;
+			break;
+		default:
+			printk(KERN_INFO "qla1280: unknown boot option %s\n",
+			       cp);
+		}
 
-    ha = (scsi_qla_host_t *) host->hostdata;
-    printk("qla1280 - PANIC:  %s\n",cp);
-    printk("Current time=0x%lx\n", jiffies);
-    printk("Number of pending commands =0x%lx\n", ha->actthreads);
-    printk("Number of SCSI queued commands =0x%lx\n", ha->qthreads);
-    printk("Number of free entries = (%d)\n",ha->req_q_cnt);
-    printk("Request Queue @ 0x%lx, Response Queue @ 0x%lx\n",
-                        ha->request_dma,
-                        ha->response_dma);
-    printk("Request In Ptr %d\n", ha->req_ring_index );
-    fp = (long *) &ha->flags;
-    printk("HA flags =0x%lx\n", *fp);
-    DEBUG2(ql_debug_print = 1;)
-    /* DEBUG2(ql1280_dump_device((scsi_qla_host_t *) host->hostdata)); */
-#ifdef  QLA1280_UNUSED 
-    qla1280_dump_regs(host);
-#endif
-    sti();  
-    panic("Ooops");  
-    /* cli(); 
-    for(;;)
-    { 
-        barrier();
-    sti();  
-    }
-    */
+		cp = strchr(ptr, ';');
+		if (cp)
+			cp++;
+		else {
+			break;
+		}
+	}
+	return 1;
 }
-#endif
 
-#ifdef  QLA1280_UNUSED 
-static void qla1280_set_flags(char * s)
+
+static int
+qla1280_get_token(char *str)
 {
+	char *sep;
+	long ret = -1;
+	int i, len;
+
+	len = sizeof(setup_token)/sizeof(struct setup_tokens);
+
+	sep = strchr(str, ':');
+
+	if (sep) {
+		for (i = 0; i < len; i++){
+
+			if (!strncmp(setup_token[i].token, str, (sep - str))) {
+				ret =  setup_token[i].val;
+				break;
+			}
+		}
+	}
+
+	return ret;
 }
+
+
+static Scsi_Host_Template driver_template = {
+	.proc_info		= qla1280_proc_info,
+	.name			= "Qlogic ISP 1280/12160",
+	.detect			= qla1280_detect,
+	.release		= qla1280_release,
+	.info			= qla1280_info,
+	.queuecommand		= qla1280_queuecommand,
+#if LINUX_VERSION_CODE >= 0x020545
+	.slave_configure	= qla1280_slave_configure,
+#endif
+	.eh_abort_handler	= qla1280_eh_abort,
+	.eh_device_reset_handler= qla1280_eh_device_reset,
+	.eh_bus_reset_handler	= qla1280_eh_bus_reset,
+	.eh_host_reset_handler	= qla1280_eh_adapter_reset,
+	.bios_param		= qla1280_biosparam,
+	.can_queue		= 255,
+	.this_id		= -1,
+	.sg_tablesize		= SG_ALL,
+	.cmd_per_lun		= 3,
+	.use_clustering		= ENABLE_CLUSTERING,
+#if LINUX_VERSION_CODE < 0x020545
+	.use_new_eh_code	= 1,
 #endif
+};
 
-/**************************************************************************
- *   qla1280_setup
- *
- *   Handle Linux boot parameters. This routine allows for assigning a value
- *   to a parameter with a ':' between the parameter and the value.
- *   ie. qla1280=max_reqs:0x0A,verbose
- **************************************************************************/
-void
-qla1280_setup(char *s, int *dummy)
-{
-    char *end, *str, *cp;
+#include "scsi_module.c"
 
-#ifdef  QLA1280_UNUSED 
-    static struct
-    {
-        const char *name;
-        int      siz;
-        void  (*func)();
-        int   arg;
-    } options[] =
-    {
-        { "dump_regs", 9,  &qla1280_dump_regs, 0 
-        },
-        { "verbose", 7, &qla1280_set_flags, 0x1 
-        },
-        { "",    0, NULL, 0 
-        }
-    };
-#endif
-
-    printk("scsi: Processing Option str = %s\n", s);
-    end = strchr(s, '\0');
-    /* locate command */
-    str = s;
-    for( cp = s; *cp && cp != end; cp++ ) 
-    {
-       cp = qla1280_get_token(cp, str);
-       printk("scsi: token str = %s\n", str);
-       /* if found execute routine */
-
-    }
-    
-}
-
-static char	*qla1280_get_token(char *cmdline, char *str )
-{
-    register	char 	*cp = cmdline;
-
-        /* skip preceeding spaces */
-        while(strchr(cp,' '))
-            ++cp;
-        /* symbol starts here */
-        str = cp;
-        /* skip char if not a space or : */
-        while (*cp && !( strchr(cp,' ') || strchr(cp,':'))  )
-            cp++;
-        *cp = '\0';
-        return( cp );
-}
-MODULE_LICENSE("GPL");
 
 /*
  * Overrides for Emacs so that we almost follow Linus's tabbing style.
@@ -6821,15 +5164,7 @@
  * of the file.
  * ---------------------------------------------------------------------------
  * Local variables:
- * c-indent-level: 2
- * c-brace-imaginary-offset: 0
- * c-brace-offset: -2
- * c-argdecl-indent: 2
- * c-label-offset: -2
- * c-continued-statement-offset: 2
- * c-continued-brace-offset: 0
- * indent-tabs-mode: nil
+ * c-basic-offset: 8
  * tab-width: 8
  * End:
  */
-
